unit PLtypes;

interface

uses
  Windows, Classes, Graphics, PLStrings;

type

 TPaperType = record
   wmm,hmm,winch,hinch : single;
   name : string;
   value : smallint;
  end;
  
const
 SizeInt  = 4;
 SizeColor  = 4;
 SizeBool  = 1;

 LEFT_A : array[0..9] of PChar = ('0001101','0011001','0010011','0111101',
              '0100011','0110001','0101111','0111011','0110111','0001011');
 LEFT_B : array[0..9] of PChar = ('0100111','0110011','0011011','0100001',
              '0011101','0111001','0000101','0010001','0001001','0010111');
 RIGHT  : array[0..9] of PChar = ('1110010','1100110','1101100','1000010',
              '1011100','1001110','1010000','1000100','1001000','1110100');
 CodLeft : array[0..9] of PChar = ('AAAAA','ABABB','ABBAB','ABBBA','BAABB',
              'BBAAB','BBBAA','BABAB','BABBA','BBABA');
 ValidEAN = ['0'..'9'];
 ValidCode39 = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%';
   Code39Table: array[1..44, 1..9] of char = (
    'NNNWWNWNN',  {1 - 0}
    'WNNWNNNNW',  {2 - 1}
    'NNWWNNNNW',  {3 - 2}
    'WNWWNNNNN',  {4 - 3}
    'NNNWWNNNW',  {5 - 4}
    'WNNWWNNNN',  {6 - 5}
    'NNWWWNNNN',  {7 - 6}
    'NNNWNNWNW',  {8 - 7}
    'WNNWNNWNN',  {9 - 8}
    'NNWWNNWNN',  {10 - 9}
    'WNNNNWNNW',  {11 - A}
    'NNWNNWNNW',  {12 - B}
    'WNWNNWNNN',  {13 - C}
    'NNNNWWNNW',  {14 - D}
    'WNNNWWNNN',  {15 - E}
    'NNWNWWNNN',  {16 - F}
    'NNNNNWWNW',  {17 - G}
    'WNNNNWWNN',  {18 - H}
    'NNWNNWWNN',  {19 - I}
    'NNNNWWWNN',  {20 - J}
    'WNNNNNNWW',  {21 - K}
    'NNWNNNNWW',  {22 - L}
    'WNWNNNNWN',  {23 - M}
    'NNNNWNNWW',  {24 - N}
    'WNNNWNNWN',  {25 - O}
    'NNWNWNNWN',  {26 - P}
    'NNNNNNWWW',  {27 - Q}
    'WNNNNNWWN',  {28 - R}
    'NNWNNNWWN',  {29 - S}
    'NNNNWNWWN',  {30 - T}
    'WWNNNNNNW',  {31 - U}
    'NWWNNNNNW',  {32 - V}
    'WWWNNNNNN',  {33 - W}
    'NWNNWNNNW',  {34 - X}
    'WWNNWNNNN',  {35 - Y}
    'NWWNWNNNN',  {36 - Z}
    'NWNNNNWNW',  {37 - -}
    'WWNNNNWNN',  {38 - .}
    'NWWNNNWNN',  {39 - blank space}
    'NWNNWNWNN',  {40 - *}
    'NWNWNWNNN',  {41 - $}
    'NWNWNNNWN',  {42 - /}
    'NWNNNWNWN',  {43 - +}
    'NNNWNWNWN'); {44 - %}

  Int25Table : array['0'..'9', 1..5] of char =
	(
  ('0', '0', '1', '1', '0'),  //0
  ('1', '0', '0', '0', '1'),  //1
  ('0', '1', '0', '0', '1'),  //2
  ('1', '1', '0', '0', '0'),  //3
  ('0', '0', '1', '0', '1'),  //4
  ('1', '0', '1', '0', '0'),  //5
  ('0', '1', '1', '0', '0'),  //6
  ('0', '0', '0', '1', '1'),  //7
  ('1', '0', '0', '1', '0'),  //8
  ('0', '1', '0', '1', '0')   //9
	);

  Papers : array [0..26] of TPaperType = (
    (wmm: 210;hmm: 297;winch: 8.2677;hinch: 11.6929;name: 'A4';value: 9),
    (wmm: 139.7;hmm: 215.9;winch: 5.5;hinch: 8.5;name: 'STATEMENT';value: 6),
    (wmm: 184.15;hmm: 266.7;winch: 7.25;hinch: 10.5;name: 'EXECUTIVE';value: 7),
    (wmm: 215.9;hmm: 279.4;winch: 8.5;hinch: 11;name: 'LETTER';value: 1),
    (wmm: 215.9;hmm: 355.6;winch: 8.5;hinch: 14;name: 'LEGAL';value: 5),
    (wmm: 148;hmm: 210;winch: 5.8267;hinch: 8.2677;name: 'A5';value: 11),
    (wmm: 297;hmm: 420;winch: 11.6929;hinch: 16.5354;name: 'A3';value: 8),
    (wmm: 279.4;hmm: 431.8;winch: 11;hinch: 17;name: 'TABLOID';value: 3),
    (wmm: 431.8;hmm: 279.4;winch: 17;hinch: 11;name: 'LEDGER';value: 4),
    (wmm: 250;hmm: 354;winch: 9.8425;hinch: 13.9370;name: 'B4';value: 12),
    (wmm: 182;hmm: 257;winch: 7.1653;hinch: 10.1181;name: 'B5';value: 13),
    (wmm: 215;hmm: 275;winch: 8.4645;hinch: 10.8267;name: 'Quarto';value: 15),
    (wmm: 110;hmm: 220;winch: 4.3307;hinch: 8.6614;name: PlEnDL;value: 27),
    (wmm: 162;hmm: 229;winch: 6.3779;hinch: 9.0157;name: PlEnC5;value: 28),
    (wmm: 324;hmm: 458;winch: 12.7559;hinch: 18.0315;name: PlEnC3;value: 29),
    (wmm: 229;hmm: 324;winch: 9.0157;hinch: 12.7559;name: PlEnC4;value: 30),
    (wmm: 114;hmm: 162;winch: 4.4881;hinch: 6.3779;name: PlEnC6;value: 31),
    (wmm: 114;hmm: 229;winch: 4.4881;hinch: 9.0157;name: PlEnC65;value: 32),
    (wmm: 250;hmm: 353;winch: 9.8425;hinch: 13.8976;name: PlEnB4;value: 33),
    (wmm: 176;hmm: 250;winch: 6.9291;hinch: 9.8425;name: PlEnB5;value: 34),
    (wmm: 176;hmm: 125;winch: 6.9291;hinch: 4.9212;name: PlEnB6;value: 35),
    (wmm: 110;hmm: 230;winch: 4.3307;hinch: 9.0551;name: 'Italy';value: 36),
    (wmm: 250;hmm: 353;winch: 9.8425;hinch: 13.8976;name: 'B4 (ISO)';value: 42),
    (wmm: 100;hmm: 148;winch: 3.9370;hinch: 5.8267;name: 'Japanese Postcard';value: 43),
    (wmm: 200;hmm: 148;winch: 7.8740;hinch: 5.8267;name: 'Japanese Doble';value: 82),
    (wmm: 220;hmm: 220;winch: 8.6614;hinch: 8.6614;name: PlEnInv;value: 47),
    (wmm: 200;hmm: 200;winch: 7.8740;hinch: 7.8740;name: PlUser;value: $100)
    );
    {    (wmm: 105;hmm: 148;name: 'A6';value: 70),
         (wmm: 297;hmm: 420;name: 'A3';value: 8),}
type
 TPLRightClickEvent = procedure (Sender: TObject; select:boolean; X,Y: Integer) of object;

 TPoint2D = record
    x,y : single;
  end;

 TRect2D = record
    X1,Y1,X2,Y2: single;
  end;

 TPointArray = array[0..0] of TPoint;
 PPointArray = ^TPointArray;
 TGridArray = array[0..0] of PPointArray;
 PGridArray = ^TGridArray;

 TPLDragType = (dtMove, dtTop, dtLeft, dtBottom, dtRight, dtPoint1, dtPoint2, dtLine, dtAlignLeft, dtAlignTop);

 TPLDrag = (drNone,drLine,drObject,drSizes,drAligns);

 TPLZoom = (zm50,zm75,zm100,zm200,zm400);

 TPLUnits = (unMM,unINCH);

 TPLBackStyle = (biNone,biImage);

 TPLFrameStyle = (fsNone,fsSingle,fsDoble);

 TPLSnap = (snPoint,snGrid,snNone);

 TPLabelType = (ltRect,ltCircle);

 TPLDrawType = (tdLab,tdPrint,tdPreview);

 TPLDrawTool = (dwLine, dwRect, dwText, dwBarCode, dwSelection, dwSymbol, dwAddText, dwImage, dwParagraph);

 TTextAlign = (taLeBa, taCeBa, taRiBa, taLeBo, taCeBo, taRiBo, taLeTo, taCeTo, taRiTo);

 TTextFormat = (tfLeft, tfRight, tfCenter, taJustify);

 TPLEleAlign = (eaLeft, eaTop, eaRight, eaBottom);

 TPLEle = (dePoint, deLine, deText, deBar, deRect, deSymbol, dePoliText, deImage, deParagraph);

 TPLBar = (baEAN13,baEAN8,baCode39,baUPCA);

 TPLDrawRuler = (duBoth, duTop, duLeft, duNone);

 function  Point2D(a,b:single) : TPoint2D;
 function  Rect2D (x1,y1,x2,y2:single):TRect2D;
 function  Coord(e:extended): integer;
 function  InCoord(i:integer): extended;
 function  MinInt(a, b: integer): integer;
 function  MaxInt(a, b: integer): integer;
 function  Ceil(X: Extended): Integer;
 function  Floor(X: Extended): Integer;
 function  MyRound(X: Extended): Integer;
 function  NormalizeRect(ARect:TRect;ml,mt,mr,mb:integer): TRect;
 function  MMTOINCH(X: single): single;
 function  INCHTOMM(X: single): single;
 function  ResizeRect(const R:TRect): TRect;
 procedure AdjustRect(var R:TRect);
 procedure MoveRect(var R:TRect;x,y:integer);
 procedure RectLeft(var R:TRect;dx:integer);
 procedure RectRight(var R:TRect;dx:integer);
 procedure RectTop(var R:TRect;dy:integer);
 procedure RectBottom(var R:TRect;dy:integer);
 procedure RotateBorder(var Border:TRect;angle,p1x,p1y,wi,he:integer);
 procedure Rotate(var Ap: TPoint; Center: TPoint; Angle:integer);
 procedure PascalStr(var s : string);
 procedure ComaStr(var s : string);

implementation

function Point2D(a,b:single) : TPoint2D;
begin
  result.x := a;
  result.y := b;
end;

function Coord(e:extended): integer;
begin
  result:= Round(e*10);
end;

function  InCoord(i:integer): extended;
begin
  result:= i/10;
end;

function Rect2D (x1,y1,x2,y2:single):TRect2D;
begin
  Result.x1:=x1;
  Result.y1:=y1;
  Result.x2:=x2;
  Result.y2:=y2;
end;

procedure Rotate(var Ap: TPoint; Center: TPoint; Angle:integer);
Var
 New: TPoint;
begin
 case Angle of
    0: New:= Ap;
   90: begin
        New.X:= Center.X + Ap.Y - Center.Y;
        New.Y:= Center.Y - Ap.X + Center.X;
       end;
  180: begin
        New.X:= Center.X - Ap.X + Center.X;
        New.Y:= Center.Y - Ap.Y + Center.Y;
       end;
  270: begin
        New.X:= Center.X - Ap.Y + Center.Y;
        New.Y:= Center.Y + Ap.X - Center.X;
       end;
 end;
 Ap:= New;
end;

function MinInt(a, b: integer): integer;
begin
  Result:= b;
  if a < b then Result := a;
end;

function MaxInt(a, b: integer): integer;
begin
  Result:= b;
  if a > b then Result := a;
end;


function Ceil(X: Extended): Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) > 0 then
    Inc(Result);
end;

function Floor(X: Extended): Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) < 0 then
    Dec(Result);
end;

function MyRound(X: Extended): Integer;
begin
 Result:= Trunc( X );
   if ( Frac( X ) >= 0.5 ) then
     Result:= Result + 1;
end;

function  NormalizeRect(ARect:TRect;ml,mt,mr,mb:integer): TRect;
var
 tmp: integer;
begin
 if ARect.Bottom < ARect.Top then
   begin
    tmp:= ARect.Bottom;
    ARect.Bottom:= ARect.Top;
    ARect.Top:= tmp;
   end;
 if ARect.Right < ARect.Left then
   begin
    tmp:= ARect.Right;
    ARect.Right:= ARect.Left;
    ARect.Left:= tmp;
   end;
 if (ARect.Right-ARect.Left) < 8 then ARect.Right:= ARect.Left + 8;
 if (ARect.Bottom-ARect.Top) < 8 then ARect.Bottom:= ARect.Top + 8;
  if ARect.Right > mr then
  begin
   tmp:= ARect.Right-ARect.Left;
   ARect.Right:= mr;
   ARect.Left:= ARect.Right - tmp;
  end;
 if ARect.Bottom  > mb then
   begin
   tmp:= ARect.Bottom-ARect.Top;
   ARect.Bottom:= mb;
   ARect.Top:= ARect.Bottom - tmp;
  end;
 if ARect.Left < ml then
  begin
   tmp:= ARect.Right-ARect.Left;
   ARect.Left:= ml;
   ARect.Right:= ARect.Left + tmp;
  end;
 if ARect.Top  < mt then
   begin
   tmp:= ARect.Bottom-ARect.Top;
   ARect.Top:= mt;
   ARect.Bottom:= ARect.Top + tmp;
  end;
 Result:= ARect;
end;

function  ResizeRect(const R:TRect): TRect;
begin
 result.Left:= R.Left+2;
 result.Top:= R.Top+2;
 result.Right:= R.Right-2;
 result.Bottom:= R.Bottom-2;
end;

function  MMTOINCH(X: single): single;
begin
 Result:= X/25.4;
end;

function  INCHTOMM(X: single): single;
begin
 Result:= X*25.4;
end;

procedure MoveRect(var R:TRect;x,y:integer);
var
 w,h:integer;
begin
 w:= R.Right-R.Left;
 h:= R.Bottom-R.Top;
 R.TopLeft:= Point(x,y);
 R.BottomRight:= Point(x+w,y+h);
end;

procedure RectLeft(var R:TRect;dx:integer);
begin
 R.Left:= dx;
end;

procedure RectRight(var R:TRect;dx:integer);
begin
 R.Right:= dx;
end;

procedure RectTop(var R:TRect;dy:integer);
begin
 R.Top:= dy;
end;

procedure RectBottom(var R:TRect;dy:integer);
begin
 R.Bottom:= dy;
end;

procedure AdjustRect(var R:TRect);
begin
 R.Right:= R.Right + 1;
 R.Bottom:= R.Bottom + 1;
end;

procedure RotateBorder(var Border:TRect;angle,p1x,p1y,wi,he:integer);
begin
 case angle of
     0 : begin
          Border.Left:= p1x;
          Border.Top := p1y;
          Border.Right:= p1x + wi;
          Border.Bottom:= p1y + he;
         end;
    90 : begin
          Border.Left:= p1x;
          Border.Top := p1y - wi;
          Border.Right:= p1x + he;
          Border.Bottom:= p1y;
         end;
  180 : begin
          Border.Left:= p1x-wi;
          Border.Top := p1y-he;
          Border.Right:= p1x;
          Border.Bottom:= p1y;
         end;
  270 : begin
          Border.Left:= p1x-he;
          Border.Top := p1y;
          Border.Right:= p1x;
          Border.Bottom:= p1y + wi;
         end;
 end;
end;

procedure PascalStr(var s : string);
Var
  i : integer;
begin
  for i:=Length(s) downto 1 do
    if s[i]='''' then Insert('''',s,i);
  s:=''''+s+'''';
end;

procedure ComaStr(var s : string);
Var
  i : integer;
begin
  for i:=Length(s) downto 1 do
    if s[i]=',' then s[i]:='.';
end;

end.




